.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include mult_desks.inc

	OpenDeskList proto :DWORD
	SaveDeskList proto :DWORD


.data?
	spath1 db 512 dup (?)
	spath2 db 512 dup (?)
	spath3 db 512 dup (?)
	spath4 db 512 dup (?)
	spath5 db 512 dup (?)
	spath6 db 512 dup (?)
.data
	spathd 		db "%USERPROFILE%\Desktop",0
	openKey     db "Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders",0
	value       db "Desktop",0
	terminator1 db "Progman",0
	terminator2 db "Explorer.exe",0
	dirs        db "Directories",0
	desk1       db "desktop1",0
	desk2       db "desktop2",0
	desk3       db "desktop3",0
	desk4       db "desktop4",0
	desk5       db "desktop5",0
	desk6       db "desktop6",0
	iniFile     db "mult_desks.ini",0
	align 4
	spaths dd OFFSET spath1, OFFSET spath2, OFFSET spath3, OFFSET spath4
		   dd OFFSET spath5, OFFSET spath6, OFFSET spathd
.code

start:

	invoke GetModuleHandle, 0
	mov	   hInstance, eax

    invoke InitCommonControls
	invoke DialogBoxParam, hInstance, 1000, 0, ADDR DlgProc, 0
	invoke ExitProcess, 0

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL bufSize:DWORD
	LOCAL strx:DWORD
	LOCAL pid:DWORD
	LOCAL handle:DWORD
	LOCAL editID:DWORD
	LOCAL opKey:DWORD
	LOCAL buf[512]:BYTE
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke OpenDeskList,  hWin
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax > 1000 && eax < 1008
			sub    eax, 1001
			mov    ecx,  eax
			mov    strx, eax
			add    eax, 1008
			mov    editID, eax
			;-----------------
			.if wParam < 1007
				invoke SendDlgItemMessage, hWin, editID, WM_GETTEXT, 512, DWORD PTR [spaths+ecx*4]
			.else
				invoke szLen, DWORD PTR [spaths+ecx*4]
			.endif
			inc    eax
			mov    bufSize, eax
			invoke RegOpenKeyEx, HKEY_CURRENT_USER, ADDR openKey, 0, KEY_SET_VALUE, ADDR opKey
			mov    ecx, strx
			invoke RegSetValueEx, opKey, ADDR value, 0, REG_EXPAND_SZ, DWORD PTR [spaths+ecx*4], bufSize
			invoke RegCloseKey, opKey
			;-----------------
			mov    pid, 0
			invoke FindWindow, ADDR terminator1, 0
			mov    ecx, eax
			invoke GetWindowThreadProcessId, ecx, ADDR pid
			.if pid
				invoke OpenProcess, PROCESS_TERMINATE, FALSE, pid
				mov    handle, eax
				.if eax
					invoke TerminateProcess, handle, 0
					invoke CloseHandle, handle
				.endif
			.endif
			invoke WinExec, ADDR terminator2, SW_SHOW
			;------------------
		.elseif eax==1014
			invoke PostMessage, hWin, WM_CLOSE, 0, 0
			invoke DialogBoxParam, hInstance, 2000, 0, ADDR DlgMini, 0
		.endif
	.elseif eax==WM_CLOSE
		invoke SaveDeskList, hWin
		invoke EndDialog, hWin, 0
	.else
		mov		eax, 0
		ret
	.endif
	mov		eax, 1
	ret

DlgProc endp

DlgMini proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL strx:DWORD
	LOCAL bufSize:DWORD
	LOCAL pid:DWORD
	LOCAL handle:DWORD
	;LOCAL editID:DWORD
	LOCAL opKey:DWORD
	;LOCAL buf[512]:BYTE
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax > 2000 && eax < 2008
			sub    eax, 2001
			mov    strx, eax
			;-----------------
			invoke szLen, DWORD PTR [spaths+eax*4]
			inc    eax
			mov    bufSize, eax
			invoke RegOpenKeyEx, HKEY_CURRENT_USER, ADDR openKey, 0, KEY_SET_VALUE, ADDR opKey
			mov    ecx, strx
			invoke RegSetValueEx, opKey, ADDR value, 0, REG_EXPAND_SZ, DWORD PTR [spaths+ecx*4], bufSize
			invoke RegCloseKey, opKey
			;-----------------
			mov    pid, 0
			invoke FindWindow, ADDR terminator1, 0
			mov    ecx, eax
			invoke GetWindowThreadProcessId, ecx, ADDR pid
			.if pid
				invoke OpenProcess, PROCESS_TERMINATE, FALSE, pid
				mov    handle, eax
				.if eax
					invoke TerminateProcess, handle, 0
					invoke CloseHandle, handle
				.endif
			.endif
			invoke WinExec, ADDR terminator2, SW_SHOW
			;------------------
		.elseif eax==2008
			invoke PostMessage, hWin, WM_CLOSE, 0, 0
			invoke DialogBoxParam, hInstance, 1000, 0, ADDR DlgProc, 0
		.endif
	.elseif eax==WM_LBUTTONDOWN
		invoke SendMessage, hWin, WM_NCLBUTTONDOWN, HTCAPTION, 0 
	.elseif eax==WM_CLOSE
		invoke EndDialog, hWin, 0
	.else
		mov		eax, 0
		ret
	.endif
	mov		eax, 1
	ret

DlgMini endp

OpenDeskList proc hWin:DWORD
	LOCAL buf[512]:BYTE
	
	invoke GetAppPath, ADDR buf
	invoke lstrcat, ADDR buf, ADDR iniFile
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk1, 0, ADDR spath1, 512, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk2, 0, ADDR spath2, 512, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk3, 0, ADDR spath3, 512, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk4, 0, ADDR spath4, 512, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk5, 0, ADDR spath5, 512, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk6, 0, ADDR spath6, 512, ADDR buf
	invoke SetDlgItemText, hWin, 1008, ADDR spath1
	invoke SetDlgItemText, hWin, 1009, ADDR spath2
	invoke SetDlgItemText, hWin, 1010, ADDR spath3
	invoke SetDlgItemText, hWin, 1011, ADDR spath4
	invoke SetDlgItemText, hWin, 1012, ADDR spath5
	invoke SetDlgItemText, hWin, 1013, ADDR spath6

	ret
OpenDeskList endp

SaveDeskList proc hWin:DWORD
	LOCAL buf[512]:BYTE
	
	invoke GetAppPath, ADDR buf
	invoke lstrcat, ADDR buf, ADDR iniFile
	invoke GetDlgItemText, hWin, 1008, ADDR spath1, 512
	invoke GetDlgItemText, hWin, 1009, ADDR spath2, 512
	invoke GetDlgItemText, hWin, 1010, ADDR spath3, 512
	invoke GetDlgItemText, hWin, 1011, ADDR spath4, 512
	invoke GetDlgItemText, hWin, 1012, ADDR spath5, 512
	invoke GetDlgItemText, hWin, 1013, ADDR spath6, 512
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk1, ADDR spath1, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk2, ADDR spath2, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk3, ADDR spath3, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk4, ADDR spath4, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk5, ADDR spath5, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk6, ADDR spath6, ADDR buf
	
	ret

SaveDeskList endp

end start
